<?php
    namespace Teknisa\PED\Controllers;
    
    use Teknisa\PED\Controllers\TeknisaCrud;
    use Teknisa\Libs\Controller\CRUD;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use Zeedhi\Framework\DataSource\Manager;
    use Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;
    use Zeedhi\Framework\DataSource\FilterCriteria;

    class Ped00600VendedorController extends TeknisaCrud {
        
        protected $dataSourceName = 'vendedor_completo';
        protected $dataSourceNameEndeVende = 'endevende_pais';
        protected $novoCodigo;
        protected $dataSourceNameToSave = '';
        protected $dataSourceManager;
        protected $parameterBagColumns = array();
        protected $environment;
        
        public function __construct($crudService, ParameterBag $parameterBag, $newCode, $environment){
            $this->novoCodigo = $newCode;
            $this->environment = $environment;
            $this->parameterBag = $parameterBag;
            parent::__construct($crudService, $parameterBag);
        
        }
        
        public function saveVendedor(DTO\Request $request, DTO\Response $response){
            $this->dataSourceNameToSave = "vendedor";
            parent::save($request,$response);
        }
        
        public function deleteVendedor(DTO\Request $request, DTO\Response $response){
            $this->dataSourceName = "vendedor";
            parent::delete($request,$response);
        }
        
        //Parte de EndeVende
        public function findEndeVende (DTO\Request\Filter $request, DTO\Response $response){
            $this->dataSourceName = $this->dataSourceNameEndeVende;
            parent::find($request,$response);
        }
        
        public function saveEndeVende(DTO\Request $request, DTO\Response $response){
            $this->dataSourceNameToSave = "endevende";
            parent::save($request,$response);
        }
        
        public function deleteEndeVende(DTO\Request $request, DTO\Response $response){
            $this->dataSourceName = "endevende";
            parent::delete($request,$response);
        }
        
        //Parte de RegiaoVendedor
        public function findRegiaoVendedor (DTO\Request\Filter $request, DTO\Response $response){
            $this->dataSourceName = "regiao_vendedor";
            parent::find($request,$response);
        }
        
        public function saveRegiaoVendedor(DTO\Request $request, DTO\Response $response){
            $this->dataSourceNameToSave = "regiaopedven";
            parent::save($request,$response);
        }
        
        public function deleteRegiaoVendedor(DTO\Request $request, DTO\Response $response){
            $this->dataSourceName = "regiaopedven";
            parent::delete($request,$response);
        }

        protected function processConditionValue($condition) 
        {
            return $condition['value'];
        }
    
        protected function populateParameterBag(FilterCriteria $filterCriteria) 
        {
    
            $conditions = array();
            foreach ($filterCriteria->getConditions() as $condition) {
                $columnName = $condition['columnName'];
                if (in_array($columnName, $this->parameterBagColumns)) {
                    $this->parameterBag->set($columnName, $this->processConditionValue($condition));
                } else {
                    $conditions[] = $condition;
                }
            }
            $newFilterCriteria = new FilterCriteria(
                $filterCriteria->getDataSourceName(),
                $conditions,
                $filterCriteria->getPage(),
                $filterCriteria->getPageSize()
            );
            return $newFilterCriteria;
        }
    }    
?>